/*
 * @Overview 사업장 등록
 * @History 2024-03-22 / 이원기 / 최초작성
 */

class Tb_bizarea_class {
  constructor(container) {
    let _this = this;
    _this.ajaxUrl = "./bizarea.ajax.php";
    this.isEdited = false;
    _this.tbList = "";
    _this.BIZ_AREA_NM  ="";
    _this.BP_NM  ="";
    _this.USEFLAG  = "";

    this.container = document.querySelector(container);
    this.table = this.container.querySelector(".hy-table");
    this.upBtn = this.container.querySelector(".up-btn") || "";
    this.downBtn = this.container.querySelector(".down-btn") || "";
    this.addBtn = this.container.querySelector(".add-btn");
    this.removeBtn = this.container.querySelector(".remove-btn");


  }

  /*
   * @Overview 데이터 세팅 함수
   * @Parameter 없음
   */
  getMainList() {
    let _this = this;
    let talert = window.setTimeout(() => {
      this.tbList.alert("Loading ...");
    }, 1000);

    _this.BIZ_AREA_NM = document.getElementById("bizarea_name").value;
    _this.BP_NM =document.getElementById("client_name").value;
    _this.USEFLAG =document.getElementById("use_flag").value;

    ajax_json({
      url: _this.ajaxUrl,
      data: { mode: "getBizareaList" ,BIZ_AREA_NM:_this.BIZ_AREA_NM,BP_NM:_this.BP_NM, USEFLAG:_this.USEFLAG },
      success: (data) => {
        if(data.code){
          _this.tbList.setData(data.data);
        }else{
          kuls_alert(err.message);
        }
      },
      error: (req, status, err) => {
        kuls_alert(err.message);
      },
      complete: () => {
        window.clearTimeout(talert);
        this.tbList.clearAlert();
      },
    });
    return true;
  }

  /*
   * @Overview 테이블 행 추가 함수
   * @Parameter 없음
   * @function 기본키, _STATUS_:I 값을 넣은 행 추가
   */
  addRow() {
    this.tbList.addRow({ _STATUS_: "I", USE_FLG: "Y" },true);
  }

  /*
   * @Overview 테이블 행 삭제 함수
   * @Parameter 없음
   * @function 선택된 모든 행 STATUS D
   */
  removeRow() {
    const selectedRows = this.tbList.getRows().filter(row=>{
      return row.getData().check ==="Y"
    });

    if(selectedRows.length > 0 ){

      // 선택된 각 행 삭제
      selectedRows.forEach((row) => {
        // STAUS D로 바꾸기
        row.getData()._STATUS_ = row.getData()._STATUS_=="I"?null:"D";
  
        const rowElement = row.getElement();
        rowElement.classList.add("remove-row");
  
      });
    }else{
      kuls_alert("삭제할 행을 선택해주세요.")
    }
  }

  /*
   * @Overview 테이블 행 선택 함수
   * @Parameter 없음
   * @function 선택된 모든 행 색 변경
   */
  rowClick(e, tgt) {
    let _this = this;
    if (tgt.isSelected()) {
      tgt.deselect();
      _this.clearRemove(tgt);
    } else {
      tgt.select();
    }
  }
  /*
   * @Overview 삭제 취소 함수
   * @Parameter 삭제 행
   * @function  클릭시 삭제 취소 & STATUS를 공란으로 변경
   */
  clearRemove(tgt){
    if(tgt._row.data._STATUS_ == "D"){
      // console.log();
      tgt._row.data._STATUS_ = "";
      tgt._row.getElement().classList.remove("remove-row")
    }
  }
  /*
   * @Overview cell 클릭 함수
   * @Parameter 클릭한 cell
   * @Function 클릭한 cell의 filed 값에 따라 토글 상태 변경 또는 팝업
   */
  cellClick(e, tgt) {
    switch (tgt.getField()) {
      case "HQ_FLG":
      case "USE_FLG":
        tgt.setValue(tgt.getValue() == "Y" ? "N" : "Y");
        tgt.getElement().classList.add("tabulator-editable");
        break;
      case "BP_CD":
        // 팝업 열기(common이나 다른 파일에 팝업 함수 정의하고, html(popup.inc.php)만들기?)
        popClient({
          BP_CD: "BP_CD",
          BP_NM: "BP_NM",
          BIZ_AREA_ADDR: "BIZ_AREA_ADDR",
          STD_CURRENCY_CD: "STD_CURRENCY_CD",
        },tgt.getRow());
        break;
      case "check":
        tgt.setValue(tgt.getValue() == "Y" ? "" : "Y");
        this.clearRemove(tgt.getRow())
      break;
    }
  }

  /*
   * @Overview 테이블 셀 수정 함수
   * @Parameter 셀
   * @function 셀 편집이 이후 저장될수 있도록 _STATUS_:U로 데이터 업데이트
   */
  cellEdited(cell) {
    cell.getData()._STATUS_ = cell.getData()._STATUS_ || "U";
  }

 


 /*
  * @Overview 추가, 수정 및 삭제 데이터 저장
  * @Parameter 없음
  * @Function _STATUS_ : U, I, D Row 인 것 php 처리.
  */
 putData() {

  // 저장 시 상태 변화 없는 row 요청 X
  if(this.tbList.getData().filter(row=> row._STATUS_).length == 0){
    this.getMainList();
    return false;
  }


  const blankObj = [];
  const reqData = [];

  this.tbList.getRows().forEach(row => {
    if(row.getData()['_STATUS_']){
      if(Object.keys(row._row.data).filter(key => key !== '_STATUS_' && key !== 'USE_FLG').every(key => {

        const value = row._row.data[key];
        return (value === undefined || value === '');
      })){
        blankObj.push(row);
      }else{
        reqData.push(row.getData());
      }
    }
  })


  const postdata = reqData.length == 0 ? false : {
    'mode': 'putBizarea',
    'reqdata': JSON.stringify(reqData),
  };

  if(!postdata){
    this.getMainList();
    return false;
  };

  if(blankObj.length !== 0){
    kuls_confirm("비어있는 행을 무시하고 진행하시겠습니까?","",()=>{
      ajax_json({
        url: this.ajaxUrl,
        data: postdata,
        success: (data)=>{
          if (data.code) {
            kuls_success("저장되었습니다.");
            this.getMainList();
          }else{
            kuls_alert(data.mesg);
          }
        },
        error: function (request, status, error) {
          kuls_alert(error.message);
        },
        complete: function () {
        }
      });

    },()=>{
      blankObj.forEach(row=>{
        row.getElement().classList.add("blank-row")
      })
    })
  }else{
    ajax_json({
      url: this.ajaxUrl,
      data: postdata,
      success: (data)=>{
        if (data.code) {
          kuls_success("저장되었습니다.");
          this.getMainList();
        }else{
          kuls_alert(data.mesg);
        }
      },
      error: function (request, status, error) {
        kuls_alert(error.message);
      },
      complete: function () {
      }
    });

  
  }

}


  /*
   * @Overview 최초 실행 함수
   * @Parameter 없음
   */
  init() {
    let _this = this;
    let timerow = Array.from(Array(24))
      .map((a, i) => i.toString().padStart(2, "0"))
      .reduce((timerow, time) => {
        return timerow.concat(
          Array.from(Array(60 / 30)).map(
            (a, i) => time + ":" + (30 * i).toString().padStart(2, "0")
          )
        );
      }, []);
    let currow = Object.keys(varsCurrency).reduce((param, key) => {
      param[key] = `${key} (${varsCurrency[key]})`;
      return param;
    }, {});

    // field 정의
    const fields = [
      { field:"check", title: "삭제", width: 50, headerSort: false,
        formatter: tb_common_funtions.formatterCheckboxIcon,
        formatterParams: { checkval: "Y" },
      },
      { formatter: "rownum", title: "No", width: 50 },
      {
        field: "BIZ_AREA_CD",
        title: "사업장코드",
        width: 150,
        editor: tb_custom_editor.pkCode,
        editorParams: {type: 'upper'}, 
        formatter: tb_custom_formatter.pkCode,
        formatterParams : {tableClass: this},
        validator:"alphanumeric",
      },
      {
        field: "BIZ_AREA_NM",
        title: "사업장명",
        width: 150,
        editor: "input",
        hozAlign:"left",
        cssClass: "editable-cell"
      },
      {
        field: "HQ_FLG",
        title: "본사",
        width: 100,
        cssClass: "tabulator-editable",
        formatter: tb_common_funtions.formatterToggleboxGreenIcon,
        formatterParams: { checkval: "Y" },
      },
      {
        field: "BP_CD",
        title: "거래처코드",
        width: 150,
        editor:tb_custom_editor.pop,
        cssClass:"tabulator-editable"
      },
      { field: "BP_NM", title: "거래처명", width: 150,hozAlign:"left",},
      { field: "BIZ_AREA_ADDR", title: "주소", width: 400,hozAlign:"left" },
      {
        field: "WORK_STD_TIME",
        title: "기준시간",
        width: 100,
        cssClass: "user-list",
        editor: "list",
        editorParams: { values: timerow },
      },
      {
        field: "LUNCH_TIME",
        title: "오후시간",
        width: 100,
        cssClass: "user-list",
        editor: "list",
        editorParams: { values: timerow },
      },
      {
        field: "STD_CURRENCY_CD",
        title: "기준화폐",
        width: 100,
        cssClass: "user-list",
        editor: "list",
        editorParams: { values: currow },
      },
      {
        field: "USE_FLG",
        title: "사용",
        width: 50,
        visible: true,
        cssClass: "tabulator-editable",
        formatter: tb_common_funtions.formatterToggleboxGreenIcon,
        formatterParams: { checkval: "Y" },
      },
    ];

    const commonFieldData = {
      headerSort: true,
      vertAlign: "middle",
      hozAlign: "center",
      resizable: "header", //Resize 는 헤더에서만 가능
      headerHozAlign: "center", //헤더 정렬
      headerSortTristate: true, //데이터 정렬 => 정/역/초기화

    };

    /*
     * @Overview tabulator 객체 생성
     * @Parameter 생성 위치(html class값)
     */
    _this.tbList = new Tabulator(this.table, {
      layout: "fitColumns",
      height: "100%",
      data: [], //기본 데이터
      columns: fields, //컬럼 설정
      columnDefaults: commonFieldData,
      headerSortElement: "<i class='bi'></i>", //정렬 아이콘
      validationMode:"highlight",
    });

    /*
     * @Overview 테이블 만들어지면 데이터 불러오기
     * @Parameter 없음
     */
    _this.tbList.on("tableBuilt", () => {
      _this.getMainList();
    });

    /*
     * @Overview 유효성 검사메세지 띄우기
     * @Parameter cell, 입력값, validators
     */
    _this.tbList.on("validationFailed", (cell, value, validators)=>{
      let errMsg = ""
      switch(validators[0].type){
        case "alphanumeric":
          errMsg = " 필드는 한글과 특수문자를 입력할 수 없습니다.";
          break;
        case "numeric":
          errMsg = " 필드는 숫자만 입력할 수 있습니다.";
          break;
        default:
          errMsg = " 필드는 "+ validators[0].parameters;
          break;
          
      };
      
      kuls_warning(cell.getColumn().getDefinition().title + errMsg );
    });

    /*
     * @Overview cell 클릭시 체크 또는 팝업
     * @Parameter 이벤트, 셀
     */
    _this.tbList.on("cellClick", (e, tgt) => {
      _this.cellClick && _this.cellClick(e, tgt);
    });
    
    /*
     * @Overview cell 수정 함수
     * @Parameter cell
     * @Function status u로 바꿀것
     */
    _this.tbList.on("cellEdited", (cell) => {
      _this.cellEdited && this.cellEdited(cell);
    });

    // 추가
    ["click", "keypress"].forEach((evt) => {
      _this.addBtn.addEventListener(evt, () => {
        _this.addRow && this.addRow();
      });
    });
    // 삭제
    ["click", "keypress"].forEach((evt) => {
      this.removeBtn.addEventListener(evt, () => {
        // 삭제 함수
        this.removeRow && this.removeRow();
      });
    });
    // 조회
    ["click", "keypress"].forEach((evt) => {
      const filterBtn = document.querySelector("#filter_btn");
      filterBtn.addEventListener(evt, () => {
        _this.getMainList && _this.getMainList();
      });
    });
    // 저장
    ["click", "keypress"].forEach((evt) => {
      const putBtn = document.querySelector("#put_btn");
      putBtn.addEventListener(evt, () => {
        _this.putData && this.putData();
      });
    });
  }
}

const Tb_bizarea = new Tb_bizarea_class("#bizarea_table");
Tb_bizarea.init();
